apiVersion: build.openshift.io/v1
kind: BuildConfig
metadata:
  annotations:
    description: Scans Container images
  name: scan-image-trivy-jenkins-pipeline
  namespace: {{ namespace }}
spec:
  strategy:
    jenkinsPipelineStrategy:
      jenkinsfile: |-
        def podLabel = "trivy-${UUID.randomUUID().toString()}"
        pipeline {
            agent {
                kubernetes {
                    cloud 'openshift'
                    label podLabel
                    containerTemplate {
                        name 'jnlp'
                        image "{{ (opsimages | json_query("[?name=='jkagtrivy'].image"))[0] }}"
                    }
                    inheritFrom 'base'
                    serviceAccount '{{ jenkins_name }}'
                }
            }
            options { timeout(time: 65, unit: 'MINUTES') }
            parameters {
{% if trivy_api_address | default(False) %}
                string(defaultValue: '{{ trivy_api_address | urlsplit('hostname') }}', description: 'Trivy Endpoint - Hostname', name: 'trivyHost')
                string(defaultValue: '{{ trivy_api_address | urlsplit('port') }}', description: 'Trivy Endpoint - Port', name: 'trivyPort')
                string(defaultValue: '{{ trivy_api_address | urlsplit('scheme') }}', description: 'Trivy Endpoint - Protocol', name: 'trivyProto')
{% else %}
                string(defaultValue: '', description: 'Trivy Endpoint - Hostname', name: 'trivyHost')
                string(defaultValue: '', description: 'Trivy Endpoint - Port', name: 'trivyPort')
                string(defaultValue: '', description: 'Trivy Endpoint - Protocol', name: 'trivyProto')
{% endif %}
                string(defaultValue: '{{ (opsimages | json_query("[?name=='jkagtrivy'].image"))[0] }}', description: 'Docker Image Address to Scan', name: 'dockerImage')
            }
            stages {
                stage('scan image') {
                    steps {
                        script {
                            openshift.withCluster() {
                                openshift.withProject() {
                                    try {
                                        currentBuild.description = "[SCANNING] ${params.dockerImage}"
                                        timeout(60) {
                                            sh """
                                            echo "==== Scanning ${params.dockerImage} ===="
{% if k8s_flavor == 'openshift' %}
                                            export TRIVY_USERNAME={{ jenkins_name }}
                                            export TRIVY_PASSWORD="\$(cat /var/run/secrets/kubernetes.io/serviceaccount/token)"
{% elif docker_registry_token | default(False) %}
                                            export TRIVY_USERNAME={{ docker_registry_token }}
{% elif docker_registry_is_http | default(False) %}
                                            export TRIVY_NON_SSL=true
{% endif %}
                                            if test "${params.trivyProto}" -a "${params.trivyPort}" -a "${params.trivyHost}"; then
                                                if ! trivy image --server "${params.trivyProto}://${params.trivyHost}:${params.trivyPort}" \\
                                                         -f json -o scan-output --timeout 10m0s "${params.dockerImage}"; then
                                                    echo "==== Returned \$? ===="
                                                fi
                                            elif ! trivy image -f json -o scan-output --timeout 10m0s "${params.dockerImage}"; then
                                                echo "==== Returned \$? ===="
                                            fi
                                            if ! test -s scan-output; then
                                                echo "==== Failed scanning image ===="
                                                rm scan-output
                                                exit 1
                                            fi
                                            echo "==== Done scanning - parsing output ===="
                                            for level in CRITICAL HIGH LOW MEDIUM UNKNOWN
                                            do
                                                echo "==== Listing criticity '\$level' ===="
                                                cat scan-output | jq ".Results[].Vulnerabilities[] | select(.Severity == \"\$level\")" 2>/dev/null
                                            done

                                            """
                                            def CRITICAL_COUNT = sh (
                                                    script: "cat scan-output | jq \"(.Results[].Vulnerabilities[] | select(.Severity == \\\"CRITICAL\\\")).VulnerabilityID\" 2>/dev/null | sort -u | awk 'END{print NR}'",
                                                    returnStdout: true
                                                ).trim()
                                            def HIGH_COUNT = sh (
                                                    script: "cat scan-output | jq \"(.Results[].Vulnerabilities[] | select(.Severity == \\\"HIGH\\\")).VulnerabilityID\" 2>/dev/null | sort -u | awk 'END{print NR}'",
                                                    returnStdout: true
                                                ).trim()
                                            def LOW_COUNT = sh (
                                                    script: "cat scan-output | jq \"(.Results[].Vulnerabilities[] | select(.Severity == \\\"LOW\\\")).VulnerabilityID\" 2>/dev/null | sort -u | awk 'END{print NR}'",
                                                    returnStdout: true
                                                ).trim()
                                            def MEDIUM_COUNT = sh (
                                                    script: "cat scan-output | jq \"(.Results[].Vulnerabilities[] | select(.Severity == \\\"MEDIUM\\\")).VulnerabilityID\" 2>/dev/null | sort -u | awk 'END{print NR}'",
                                                    returnStdout: true
                                                ).trim()
                                            def UNKNOWN_COUNT = sh (
                                                    script: "cat scan-output | jq \"(.Results[].Vulnerabilities[] | select(.Severity == \\\"UNKNOWN\\\")).VulnerabilityID\" 2>/dev/null | sort -u | awk 'END{print NR}'",
                                                    returnStdout: true
                                                ).trim()
                                            sh "rm -f scan-output"
                                            def score = "UNKNOWN"
                                            if (CRITICAL_COUNT != "0") { score = "CRITICAL" }
                                            else {
                                                if (HIGH_COUNT != "0") { score = "WARNING" }
                                                else { score = "OK" }
                                            }
                                            def notifyMsg = """
                                            [${score}] ${params.dockerImage}
                                            critical: ${CRITICAL_COUNT}
                                            high: ${HIGH_COUNT}
                                            low: ${LOW_COUNT}
                                            medium: ${MEDIUM_COUNT}
                                            unknown: ${UNKNOWN_COUNT}
                                            """.stripIndent()
                                            currentBuild.description = notifyMsg
                                            echo "${notifyMsg}"
                                            def notifyPost = notifyMsg.replaceAll('"', "'")
                                            echo "${notifyMsg}"
                                            try {
                                                withCredentials([string(credentialsId: "jenkins-notify-slack", variable: 'POST_URI')]) {
                                                    def postSlackData = "{ \"text\": \"${notifyPost}\" }"
                                                    try { sh "curl -s --data-urlencode 'payload=$postSlackData' 'https://hooks.slack.com/services/${POST_URI}'" }
                                                    catch(e) { echo "In catch block notifying slack - ${e}" }
                                                }
                                            } catch(e) { echo "Did not find slack credentials - would not notify" }
                                        }
                                    } catch(e) {
                                        echo "In catch scanning image - ${e}"
                                        throw e
                                    }
                                }
                            }
                        }
                    }
                }
            }
            post {
                always { echo "Done scanning ${params.dockerImage}" }
                changed { echo "changed?" }
                failure { echo "Build failed (${params.jobRetryCount} out of ${params.jobMaxRetry})" }
                success { echo "success!" }
                unstable { echo "unstable?" }
            }
        }
    type: JenkinsPipeline
